#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <fstream>
#include "HashUtility.h"
using namespace std;



int main(){

	unordered_map<string, int, sum_of_components_hash> board_counts1;
	unordered_map<string, int, polynomial_hash> board_counts2;
	unordered_map<string, int, cyclic_hash> board_counts3;


	ifstream inf("boards.txt");
	string line;
	while (getline(inf,line).good()){
		board_counts1[line]++;
		board_counts2[line]++;
		board_counts3[line]++;
	}
	

	for (unordered_map<string, int>::iterator itr1=board_counts1.begin(); itr1!=board_counts1.end(); itr1++)
		cout << itr1->first << " : " << itr1->second << endl;

	for (unordered_map<string, int>::iterator itr2=board_counts2.begin(); itr2!=board_counts2.end(); itr2++)
                cout << itr2->first << " : " << itr2->second << endl;

        for (unordered_map<string, int>::iterator itr3=board_counts3.begin(); itr3!=board_counts3.end(); itr3++)
                cout << itr3->first << " : " << itr3->second << endl;

	inf.close();
}

